package supperSlonic.emrWorkflow.Builders.Utils;

import supperSlonic.emrWorkflow.JobFlowContext;
import supperSlonic.emrWorkflow.Builders.BaseConfigurationBuilder;

public class HBaseConfigurationBuilder extends BaseConfigurationBuilder
{	
	private static final String ARGS_SEPARATOR = "-s";
	private static final String PREFIX = "HBaseConf.";
	private static final String NAME = "Configure HBase";
	private static final String PATH = "s3://us-east-1.elasticmapreduce/bootstrap-actions/configure-hbase";
	
	public HBaseConfigurationBuilder(JobFlowContext context)
	{
		super(context, ARGS_SEPARATOR, PREFIX, NAME, PATH);
	}
}
